
#include <vgagl.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "sigdef.h"
#include "screendef.h"

#define ZZ 0.0000001

void show_cw(char *s);


void detect_previous_character(int char_pos)
{
int charlen,charbits;
if(char_pos < 1)end_program(674421);
if(cw[char_pos].type != CW_SPACE && cw[char_pos].type != CW_WORDSEP)
  {
  show_cw("ERROR in detect_previous_character");
  end_program(674422);
  }
// We have been called properly with the pointer on a space.
// Step backwards and see if it is preceeded by something
// we are likely to interpret correctly.
cw_ptr=char_pos-1;
charlen=0;
charbits=0;
while(cw_ptr >= 0 && (cw[cw_ptr].type==CW_DASH || cw[cw_ptr].type==CW_DOT))
  {
  charbits++;
  charlen+=cw[cw_ptr].len;
  cw_ptr--;
  }
if(charbits==0)return;
fprintf(dmp,"\ncharbits: %d",charbits);
}


void find_close_parts(void)
{
float t1, t2, r1, lsum_real, lsum_ideal;
int i, k;
cw_ptr=1;
lsum_real=0;
lsum_ideal=0;
t1=0;
t2=0;
while(cw_ptr < no_of_cwdat)
  {
// Get the length of the gap between decoded dots and dashes.
  r1=cw[cw_ptr].sep/cwbit_pts;
  r1-=0.5*(cw[cw_ptr].len+cw[cw_ptr-1].len);
  if(r1 < 0) r1=0;
  k=(int)(r1)&0xfffffffe;
  if(r1-k > 1)k+=2;
// Accumulate regions where we see the keying reasonably well.
  if(k<=8 && fabs(r1-k) < 0.25)
    {
    lsum_real+=cw[cw_ptr].sep;
    lsum_ideal+=k+0.5*(cw[cw_ptr].len+cw[cw_ptr-1].len);
    }
  else
    {
    t1+=lsum_ideal*lsum_real;  //ideal*ideal*(real/ideal)  
    t2+=lsum_ideal*lsum_ideal; 
    lsum_real=0;
    lsum_ideal=0;
    }  
  cw_ptr++;
  }
// Get the average ratio of real to ideal, weighted by ideal squared.
// Store as an improved value for cw speed
cwbit_pts=t1/t2;
// Compute the length of un-decoded regions and store in cw[].unkn
i=baseband_size+cw[0].midpoint-baseb_px;
i&=baseband_mask;
cw[0].unkn=(float)(i)/cwbit_pts-cw[0].len/2;
cw_ptr=1;
while(cw_ptr < no_of_cwdat)
  {
  r1=cw[cw_ptr].sep/cwbit_pts;
  r1-=0.5*(cw[cw_ptr].len+cw[cw_ptr-1].len);
  if(r1 < 0) r1=0;
  k=(int)(r1)&0xfffffffe;
  if(r1-k > 1)k+=2;
  cw[cw_ptr].unkn=k;
  cw_ptr++;
  }
}


void first_morse_decode(void)
{
char chr;
int i, j, charflag,charlen,charval,charbits;
int first_char_pos;
// We have stored dashes and dots that are next to a dash.
// Look through the data and see if we can find characters.
cw_decoded_chars=0;
first_char_pos=-1;
/*
typedef struct {
unsigned char type;    // Part type (CW_DOT, CW_SPACE,....A,B,C,...)
unsigned char unkn;    // Number of unknown states before this part
unsigned char down;    // Number of states to lower character boundary
unsigned char len;     // Length of character in states 
*float midpoint;
*float sep;
*float re;
*float im;
}MORSE_DECODE_DATA;
// Defines for MORSE_DECODE_DATA.type (cw.type)
// Note that CW_DASH must have the lowest value.
#define CW_WORDSEP 255
#define CW_SPACE 254
#define CW_DOT 253
#define CW_DASH 252
//   name     data    length
// CW_DASH    |---_|     4
//              ^
// CW_DOT     |-_|       2 
//             ^
// CW_SPACE   |__|       2
//             ^  
// CW_WORDSEP |____|     4 
//              ^
// The way the midpoint is defined does not include the trailing
// key-up of each cw part.
*/
//show_cw("first_morse_decode enter");


cw_ptr=1;
charflag=0;
charlen=0;
charval=0;
charbits=0;
while(cw_ptr < no_of_cwdat)
  {
  if(cw[cw_ptr].unkn != 0)charflag=0;
  if(charbits != 0 && charflag == 1 && 
               (cw[cw_ptr].type == CW_WORDSEP || cw[cw_ptr].type == CW_SPACE))
    {
// This is a character surrounded by spaces.   
// Get an ascii character from the table.

    if(charbits > 6)
      {
      chr=243;
      }
    else
      {
      cw_decoded_chars++;
      chr=morsascii[charbits-1][charval];
      }
    fprintf(dmp,"\ndecode:%d   %d   %c[%d]",charbits,charval,chr,chr);    
// The current character extends from cw_ptr-charbits to cw_ptr-1 
// Include the trailing space at cw_ptr in the character, 
// but leave trailing word separators unchanged.
// If a word separator preceeded by a character is present 
// at cw_ptr-charbits-1, replace the word separator by a blank.
fprintf(dmp,"\n%d to %d",cw_ptr-charbits,cw_ptr-1);
    i=cw_ptr-charbits;
    if(i >= 2)
      {
      if(cw[i-1].type == CW_WORDSEP && cw[i-2].type < CW_DASH)
        {
        fprintf(dmp,"\nINSERT BLANK");
        cw[i-1].type=' ';
        }
      }  
    if(first_char_pos < 0 )first_char_pos=i;
    cw[i].type=chr;
    cw[i].len=charlen;
    j=cw_ptr;
    if(cw[cw_ptr].type == CW_SPACE)j++;
    cw_ptr=i;
    i++;
    while(j < no_of_cwdat)
      {
      cw[i]=cw[j];
      i++;
      j++;
      }
    no_of_cwdat=i-1;  
    }
  if(cw[cw_ptr].type != CW_DASH && cw[cw_ptr].type != CW_DOT)
    {
    charflag=1;
    charlen=0;
    charval=0;
    charbits=0;
    }
  else
    {
    charbits++;
    charlen+=cw[cw_ptr].len;  
    charval<<=1;
    if(cw[cw_ptr].type==CW_DASH)charval++;
    }  
  cw_ptr++;
  }
//show_cw("first_morse_decode exit");
if(cw_decoded_chars > 0)
  {
  if(first_char_pos > 1)
  fprintf(dmp,"\nFirst char pos: %d",first_char_pos);
  detect_previous_character(first_char_pos-1);
  }
}



void remove_dash(void)
{
float t1;
int ia, ib;
ia=cw[cw_ptr].midpoint-0.5*dash_pts+baseband_size;
ia&=baseband_mask;
ib=(ia+dash_pts+1)&baseband_mask;
while(ia != ib)
  {
  baseb_fit[2*ia]=0;
  baseb_fit[2*ia+1]=0;
  ia=(ia+1)&baseband_mask;
  }
ia=cw_ptr+1;
while(ia < no_of_cwdat)
  {
  cw[ia-1]=cw[ia];
  ia++;
  }
if(cw_ptr !=0)
  {  
  t1=cw[cw_ptr].midpoint-cw[cw_ptr-1].midpoint;
  if(t1 < 0)t1+=baseband_size;
  cw[cw_ptr].sep=t1;
  }
no_of_cwdat--;
}  


void set_long_region_envelope(void)
{
int i, ia, ib, len;
float t1,t2,r1,r2;
// We have two dashes pointed to by cw_ptr and cw_ptr-1.
// We know the envelope at these points but the separation is large.
// Set envelope at both ends by extrapolation.
ia=cw[cw_ptr-1].midpoint;
ia+=(dash_pts>>2);
ia&=baseband_mask;
ib=cw[cw_ptr].midpoint;
t1=cw[cw_ptr-1].re;
r1=cw[cw_ptr-1].im;
t2=cw[cw_ptr].re;
r2=cw[cw_ptr].im;
ib+=baseband_size-(dash_pts>>2);
ib&=baseband_mask;
len=10*cwbit_pts;
i=0;
while( i < len )
  {
  baseb_envelope[2*ia]=t1;
  baseb_envelope[2*ia+1]=r1;
  baseb_envelope[2*ib]=t2;
  baseb_envelope[2*ib+1]=r2;
  ia=(ia+1)&baseband_mask;
  if(ia == ib)goto avgenv;
  ib=(ib+baseband_mask)&baseband_mask;
  if(ia == ib)goto avgenv;
  i++;
  }
return;
avgenv:;
t1=0.5*(t1+t2);
r1=0.5*(r1+r2);
while( i < len )
  {
  baseb_envelope[2*ia]=t1;
  baseb_envelope[2*ia+1]=r1;
  baseb_envelope[2*ib]=t1;
  baseb_envelope[2*ib+1]=r1;
  ia=(ia+1)&baseband_mask;
  ib=(ib+baseband_mask)&baseband_mask;
  i++;
  }
}  


void set_region_envelope(void)
{
int ia, ib, len;
float t1,t2,r1,r2;
// We have two dashes pointed to by cw_ptr and cw_ptr-1.
// We know the envelope at these points.
// Set a reasonable envelope across the interval by linear interpolation.
ia=cw[cw_ptr-1].midpoint+(dash_pts>>2);
ia&=baseband_mask;
ib=baseband_size+cw[cw_ptr].midpoint-(dash_pts>>2);
ib&=baseband_mask;
t1=cw[cw_ptr-1].re;
r1=cw[cw_ptr-1].im;
len=(ib-ia+baseband_size)&baseband_mask;
t2=(cw[cw_ptr].re-t1)/len;
r2=(cw[cw_ptr].im-r1)/len;
while(ia != ib)
  {
  t1+=t2;
  r1+=r2;
  baseb_envelope[2*ia]=t1;
  baseb_envelope[2*ia+1]=r1;
  ia=(ia+1)&baseband_mask;
  }
}  

void clear_region(void)
{
int ia, ib;
// We have two dashes pointed to by cw_ptr and cw_ptr-1.
// We know the envelope at these points.
// Clear baseb_fit across the interval.
ia=cw[cw_ptr-1].midpoint+0.5*dash_pts+baseband_size;
ib=cw[cw_ptr].midpoint-0.5*dash_pts+1+baseband_size;
ia&=baseband_mask;
ib&=baseband_mask;
while(ia != ib)
  {
  baseb_fit[2*ia]=0;
  baseb_fit[2*ia+1]=0;
  ia=(ia+1)&baseband_mask;
  }
}  

void accurate_store_dash(void)
{
float sum1,sum2;
float re, im, c0, t1, t2, f1, f2;
int ia, ib, ja, skipflag;
sum1=0;
sum2=0;
re=cg_wave_re;
im=cg_wave_im;
ia=cg_wave_midpoint+0.5;
if(ia < cg_wave_midpoint) ia++;
ia &= baseband_mask;
ib=(ia+baseband_mask)&baseband_mask;
if( (dash_pts&1) == 0)
  {
  c0=0.5*(dash_pts-1);
  }
else
  {
  c0=(dash_pts>>1)+1;
  }  
// cg_wave_midpoint points to the center of the dash. 
// c0 points to the center of dash_waveform.
store:;
skipflag=0;
t1=ia-cg_wave_midpoint;
if(t1<0)t1+=baseband_size;
t1=c0+t1;
if(t1 >= dash_pts-1)
  {
  baseb_fit[2*ia  ]=0;
  baseb_fit[2*ia+1]=0;
  skipflag=1;
  }
else
  {
  ja=t1;
  t1-=ja;
  t2=1-t1;
  f1=t2*dash_waveform[2*ja  ]+t1*dash_waveform[2*ja+2];
  f2=t2*dash_waveform[2*ja+1]+t1*dash_waveform[2*ja+3];
  baseb_fit[2*ia  ]=re*f1+im*f2;
  baseb_fit[2*ia+1]=re*f2-im*f1;
  sum1+=baseb_totpwr[ia];
  t1=baseb[2*ia  ]-baseb_fit[2*ia  ];
  t1=baseb[2*ia+1]-baseb_fit[2*ia+1];
  sum2+=t1*t1+t2*t2;
  }
t1=cg_wave_midpoint-ib;
if(t1<0)t1+=baseband_size;
t1=c0-t1/1;
if(t1 < 1)
  {
  baseb_fit[2*ib  ]=0;
  baseb_fit[2*ib+1]=0;
  skipflag++;
  }
else
  {
  ja=t1;
  t1-=ja;
  t2=1-t1;
  f1=t2*dash_waveform[2*ja  ]+t1*dash_waveform[2*ja+2];
  f2=t2*dash_waveform[2*ja+1]+t1*dash_waveform[2*ja+3];
  baseb_fit[2*ib  ]=re*f1+im*f2;
  baseb_fit[2*ib+1]=re*f2-im*f1;
  sum1+=baseb_totpwr[ia];
  t1=baseb[2*ia  ]-baseb_fit[2*ia  ];
  t1=baseb[2*ia+1]-baseb_fit[2*ia+1];
  sum2+=t1*t1+t2*t2;
  }
ia=(ia+1)&baseband_mask;
ib=(ib+baseband_mask)&baseband_mask;
if(skipflag != 2)goto store;
cg_wave_dat=sum1/dash_pts;
cg_wave_err=sum2/dash_pts;
}


float check_dash(float pos)
{
int ia, ib, ja, sw;
float c0, t1, t2, r1, r2, f1, f2;
float p,err1,err2;
// Place a dash at pos using the phase/amplitude information 
// in baseb_envelope.
// Calculate the transformation required for optimum similarity
// between the observed waveform in baseb and the dash we have stored.
err1=0;
err2=0;
p=0;
ib=pos;
if( pos-ib < 0.001)pos+=0.001; 
ia=(ib+1)&baseband_mask;
if( (dash_pts&1) == 0)
  {
  c0=0.5*(dash_pts-1);
  }
else
  {
  c0=(dash_pts>>1)+1;
  }  
// pos is the center of where we want to place a dash.
sw=0;
while( sw!=2)
  {
  sw=0;
  t1=ia-pos;
  if(t1<0)t1+=baseband_size;
  t1=c0+t1;
  if(t1 >= dash_pts-1)
    {
    baseb_fit[2*ia  ]=0;
    baseb_fit[2*ia+1]=0;
    sw++;
    }
  else
    {
    ja=t1;
    t1-=ja;
    t2=1-t1;
    f1=t2*dash_waveform[2*ja  ]+t1*dash_waveform[2*ja+2];
    f2=t2*dash_waveform[2*ja+1]+t1*dash_waveform[2*ja+3];
    r1=baseb_envelope[2*ia  ];
    r2=baseb_envelope[2*ia+1];
    baseb_fit[2*ia  ]=r1*f1+r2*f2;
    baseb_fit[2*ia+1]=r1*f2-r2*f1;
    }
  err1+=baseb_totpwr[ia];
  p+=baseb_fit[2*ia  ]*baseb_fit[2*ia  ]+baseb_fit[2*ia+1]*baseb_fit[2*ia+1];
  err2+=(baseb_fit[2*ia  ]-baseb[2*ia  ])*(baseb_fit[2*ia  ]-baseb[2*ia  ])+
        (baseb_fit[2*ia+1]-baseb[2*ia+1])*(baseb_fit[2*ia+1]-baseb[2*ia+1]);
  t1=pos-ib;
  if(t1<0)t1+=baseband_size;
  t1=c0-t1;
  if(t1 < 1)
    {
    baseb_fit[2*ib  ]=0;
    baseb_fit[2*ib+1]=0;
    sw++;
    }
  else
    {
    ja=t1;
    t1-=ja;
    t2=1-t1;
    f1=t2*dash_waveform[2*ja  ]+t1*dash_waveform[2*ja+2];
    f2=t2*dash_waveform[2*ja+1]+t1*dash_waveform[2*ja+3];
    r1=baseb_envelope[2*ib  ];
    r2=baseb_envelope[2*ib+1];
    baseb_fit[2*ib  ]=r1*f1+r2*f2;
    baseb_fit[2*ib+1]=r1*f2-r2*f1;
    }
  err1+=baseb_totpwr[ib];
  p+=baseb_fit[2*ib  ]*baseb_fit[2*ib  ]+baseb_fit[2*ib+1]*baseb_fit[2*ib+1];
  err2+=(baseb_fit[2*ib  ]-baseb[2*ib  ])*(baseb_fit[2*ib  ]-baseb[2*ib  ])+
        (baseb_fit[2*ib+1]-baseb[2*ib+1])*(baseb_fit[2*ib+1]-baseb[2*ib+1]);
  ia=(ia+1)&baseband_mask;
  ib=(ib+baseband_mask)&baseband_mask;
  }
// In a perfect fit (noise free) we expect this result:
//
//       Case     err1     err2
//       dash      p        0
//       space     0        p
//
// Due to the presence of noise we expect this instead:
//
//       Case     err1     err2       err1-err2
//       dash     p+n        n           p
//       space     n        p+n         -p 

return (err1-err2)/p;
}    


float check_dot(float pos)
{
int ia, ib, ja, sw;
float c0, t1, t2, r1, r2, f1, f2;
float p,err1,err2;
// Place a dot at pos using the phase/amplitude information 
// in baseb_envelope.
// Calculate the transformation required for optimum similarity
// between the observed waveform in baseb and the dot we have stored.
err1=0;
err2=0;
p=0;
ib=pos;
if( pos-ib < 0.001)pos+=0.001; 
ia=(ib+1)&baseband_mask;
if( (dot_pts&1) == 0)
  {
  c0=0.5*(dot_pts-1);
  }
else
  {
  c0=(dot_pts>>1)+1;
  }  
// pos is the center of where we want to place a dot.
sw=0;
while( sw!=2)
  {
  sw=0;
  t1=ia-pos;
  if(t1<0)t1+=baseband_size;
  t1=c0+t1;
  if(t1 >= dot_pts-1)
    {
    baseb_fit[2*ia  ]=0;
    baseb_fit[2*ia+1]=0;
    sw++;
    }
  else
    {
    ja=t1;
    t1-=ja;
    t2=1-t1;
    f1=t2*dot_waveform[2*ja  ]+t1*dot_waveform[2*ja+2];
    f2=t2*dot_waveform[2*ja+1]+t1*dot_waveform[2*ja+3];
    r1=baseb_envelope[2*ia  ];
    r2=baseb_envelope[2*ia+1];
    baseb_fit[2*ia  ]=r1*f1+r2*f2;
    baseb_fit[2*ia+1]=r1*f2-r2*f1;
    }
  err1+=baseb_totpwr[ia];
  p+=baseb_fit[2*ia  ]*baseb_fit[2*ia  ]+baseb_fit[2*ia+1]*baseb_fit[2*ia+1];
  err2+=(baseb_fit[2*ia  ]-baseb[2*ia  ])*(baseb_fit[2*ia  ]-baseb[2*ia  ])+
        (baseb_fit[2*ia+1]-baseb[2*ia+1])*(baseb_fit[2*ia+1]-baseb[2*ia+1]);
  t1=pos-ib;
  if(t1<0)t1+=baseband_size;
  t1=c0-t1;
  if(t1 < 1)
    {
    baseb_fit[2*ib  ]=0;
    baseb_fit[2*ib+1]=0;
    sw++;
    }
  else
    {
    ja=t1;
    t1-=ja;
    t2=1-t1;
    f1=t2*dot_waveform[2*ja  ]+t1*dot_waveform[2*ja+2];
    f2=t2*dot_waveform[2*ja+1]+t1*dot_waveform[2*ja+3];
    r1=baseb_envelope[2*ib  ];
    r2=baseb_envelope[2*ib+1];
    baseb_fit[2*ib  ]=r1*f1+r2*f2;
    baseb_fit[2*ib+1]=r1*f2-r2*f1;
    }
  err1+=baseb_totpwr[ib];
  p+=baseb_fit[2*ib  ]*baseb_fit[2*ib  ]+baseb_fit[2*ib+1]*baseb_fit[2*ib+1];
  err2+=(baseb_fit[2*ib  ]-baseb[2*ib  ])*(baseb_fit[2*ib  ]-baseb[2*ib  ])+
        (baseb_fit[2*ib+1]-baseb[2*ib+1])*(baseb_fit[2*ib+1]-baseb[2*ib+1]);
  ia=(ia+1)&baseband_mask;
  ib=(ib+baseband_mask)&baseband_mask;
  }
// In a perfect fit (noise free) we expect this result:
//
//       Case     err1     err2
//       dot       p        0
//       space     0        p
//
// Due to the presence of noise we expect this instead:
//
//       Case     err1     err2       err1-err2
//       dot      p+n        n           p
//       space     n        p+n         -p 
return (err1-err2)/p;
}    

void store_dot(void)
{
int ir,ia,ib;
float t2,r2;
// We calculated the dot product between the current waveform and 
// the average waveform for a dash when cg_wave_start was computed.
// Normalise and use to set up fitted waveforms.
ia=cg_wave_midpoint-0.5*dot_pts+baseband_size;
ia&=baseband_mask;
ib=(ia+dot_pts)&baseband_mask;
t2=cg_wave_re;
r2=cg_wave_im;
// Store the average waveform at the optimum phase and amplitude giving
// the smallest residue when subtracted from baseb.
ir=0;
while(ia != ib)
  {
  baseb_fit[2*ia  ]=t2*dot_waveform[2*ir  ]+r2*dot_waveform[2*ir+1];
  baseb_fit[2*ia+1]=t2*dot_waveform[2*ir+1]-r2*dot_waveform[2*ir  ];
  ir++;
  ia=(ia+1)&baseband_mask;
  }
}

void store_dash(void)
{
short int ir;
int ia,ib;
float t2,r2;
// We calculated the dot product between the current waveform and 
// the average waveform for a dash when cg_wave_start was computed.
// Normalise and use to set up fitted waveforms.
ia=cg_wave_midpoint-0.5*dash_pts+baseband_size;
ia&=baseband_mask;
ib=(ia+dash_pts)&baseband_mask;
t2=cg_wave_re;
r2=cg_wave_im;
// Store the average waveform at the optimum phase and amplitude giving
// the smallest residue when subtracted from baseb.
ir=0;
while(ia != ib)
  {
  baseb_fit[2*ia  ]=t2*dash_waveform[2*ir  ]+r2*dash_waveform[2*ir+1];
  baseb_fit[2*ia+1]=t2*dash_waveform[2*ir+1]-r2*dash_waveform[2*ir  ];
  ir++;
  ia=(ia+1)&baseband_mask;
  }
}

